/* ipqdlib.h - */

/* Copyright (c) 2006, TeamF1 Inc. */

/*
modification history
--------------------
01a,21Feb06,srk created
*/



#ifndef __INCipqdlibh
#define __INCipqdlibh

/* includes */
#include <stdio.h> 
#include <stdlib.h> 
#include <errno.h> 
#include <string.h> 
#include <sys/types.h> 
#include <netinet/in.h> 
#include <sys/socket.h> 
#include <sys/wait.h>
#include <pthread.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <linux/netfilter.h>
#include <libipq/libipq.h>
#include <linux/ip.h>

/* defines */

#define gplPrintf  printf
#define GPL_PRINTF(format,args...)  printf(format, ##args)



#ifdef TM_DEBUG
#define tmgpldprintf gplPrintf
#else
#define tmgpldprintf(x...)
#endif /* TM_DEBUG */


#define GPL_PID_FILE     "/var/gpl.pid"


#define GPL_RET_ERROR(errCode, errLabel) \ 
     do {                                                                   \
            GPL_PRINTF("At %s:%d -> %s\n", __FILE__, __LINE__,#errCode); \
            goto errLabel;                                                     \
        } while(0)


#define TMGPL_RET_ERROR(errcode)   GPL_RET_ERROR(errCode, tmRetError)


#define TMGPL_CMD_BUF_SIZE       (128)


#define LOCAL static
#define OK 0
#define ERROR -1
#define SPACE   ' '     /* the space character */

#define tmgpldCmdCat(cmdBuf, fmt...)                               \
        do {                                                     \
            result = snprintf(cmdBuf+bufOffSet,                  \
                              TMGPL_CMD_BUF_SIZE-bufOffSet, fmt); \
            if (result == 0)                                     \
                TMGPL_RET_ERROR(TM_ERR_CMD_TOO_LONG);           \
            bufOffSet += result;                                 \
        } while(0)

/* typedef */

typedef int STATUS;

char ** tmgpldStrBreak ( char *);
int tmgpldCmdExec ( char *);
               
#endif /* __INCipqdlibh */
